︠46335541-e7f2-4de2-877c-ddf686e99f20s︠
# ALGORITMO 1
def supersing(E, l):
    p= 4*prod(l)-1
    d=1
    fin= None
    P= E.random_point()
    for i in range(len(l)):
        Q= Integer((p+1)/l[i])*P; Q
        if(l[i]*Q!= E(0)):
            print("Ordinaria")
            fin= 1
            break
        else:
            d= d*l[i]; d
            4*sqrt(p).numerical_approx()
            if(bool(d>4*sqrt(p))==True):
                print("Supersingular")
                fin= 1
                break
    if(fin!=1):
        print("El orden del punto aleatorio es demasiado pequeño. Vuélvelo a intentar")
        
        
︡66bb6c04-9294-4027-a7a3-4a00c411a0aa︡{"done":true}
︠d7870561-085f-400c-a7f6-58d084f3f3c5s︠
# ALGORITMO 1 para curvas de Montgomery
def supersing_A(A, l):
    p= 4*prod(l)-1
    E= EllipticCurve(GF(p), [0,A,0,1,0])
    d=1
    fin= None
    P= E.random_point()
    for i in range(len(l)):
        Q= Integer((p+1)/l[i])*P; Q
        if(l[i]*Q!= E(0)):
            print("Ordinaria")
            fin= 1
            break
        else:
            d= d*l[i]; d
            4*sqrt(p).numerical_approx()
            if(bool(d>4*sqrt(p))==True):
                print("Supersingular")
                fin= 1
                break
    if(fin!=1):
        print("El orden del punto aleatorio es demasiado pequeño. Vuélvelo a intentar")
        
        

︡ca499d28-836f-4040-9c10-60d2a321aa0c︡{"done":true}
︠da065510-f924-4c03-b745-38d5436dca11s︠
# ALGORITMO 2
import numpy
def mult_P(P): # funcio que retorna una llista amb les coordenades x dels multiples de P (menys el neutre). La llista te mida l-1
    l= P.order()
    P_list= [P[0]]
    for i in range(2, l): 
        P_list.append((i*P)[0])
    return P_list

def tau(P):
    P_list= mult_P(P)
    return numpy.prod(P_list)

def sigma(P):
    P_list= mult_P(P)
    sigma= P_list[0]-1/P_list[0]
    for i in range(1, len(P_list)):
        sigma+= (P_list[i]-1/P_list[i])
    return sigma

def class_group_action(p, A, l, es):
    F= GF(p)
    e= copy(es)
    for i in range(len(e)):
        while(e[i]!=0):
            k=1
            x= F.random_element(); 'x=' + str(x)
            if(Mod(x^3+A*x^2+x, p).is_square()): # si és un quadrat entra al bucle
                s= 1
                K= GF(p)
                E= EllipticCurve(K, [0,A,0,1,0]); E
                P= E.lift_x(x); P # dóna un punt de E amb coordenada x
            else:
                s= -1
                K= GF(p^2, 'a')
                E= EllipticCurve(K, [0,A,0,1,0]); E
                P= E.lift_x(x); P # dóna un punt de E amb coordenada x
            S= [idx for idx, val in enumerate(e) if val != 0 and sgn(val)==s]; 
            if not S:
                continue # si S és buit, triem un altre x
            for idx in S:
                k*=l[idx]
            Q= Integer((p+1)/k)*P
            for idx in S:
                R= Integer(k/l[idx])*Q
                if(R==E(0)):
                    continue # passem al següent índex
                tau_0= tau(R)
                if(tau_0 != 0): # si cap x_i és 0 aleshores tau!=0 i per tant necessitem sigma
                    sigma_0= sigma(R)
                    B= tau_0*(A-3*sigma_0)
                else:
                    B=0 # si tau=0 aleshores B=0
                EB= EllipticCurve(K, [0,B,0,1,0])
                phi= EllipticCurveIsogeny(E, R, codomain=EB) # formula explicita de la isogenia de E a EB
                A= B
                E= EB
                Q= phi(Q); Q
                k= k/l[idx]
                e[idx]-= s
    #print EB
    return A
︡c008257a-d936-4533-9ae0-13cd80a62354︡{"done":true}
︠f0aaee85-a045-4797-bff0-c22ff5c166a1s︠
# LISTA ELKIES PRIMES
l_1= [3,5,7,11,13,17,19,23,29,31,37]
l_2= [3,5,7,11,13,17,19,23,29,31,37,59]
l_3= [3,5,7,11,13,17,19,23,29,31,37,41,61]
l_4= [3,5,7,11,13,17,19,23,29,31,37,41,43,97]
l_5= [3,5,7,11,13,17,19,23,29,31,37,41,47,73]
l_6= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,83]
l_7= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,131]
l_8= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,131]
l_9= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,113]
l_10= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,113,131]
l_11= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,103,113,131,157]
l_12= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,103,113,131,157,167]
l_13= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,103,113,131,157,167,181]
l_14= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,103,113,131,157,167,181,193]
l_15= [3,5,7,11,13,17,19,23,29,31,37,41,47,73,79,83,89,97,103,113,131,157,167,181,193,257]
p=4*prod(l_15)-1
p.is_prime()
len(l_15)
e=[randint(-10,10) for i in range(len(l_15))]; e

︡b336b671-3d71-4aad-88b7-d4161aa8bdda︡{"stdout":"True\n"}︡{"stdout":"26\n"}︡{"stdout":"[-2, 9, 6, 10, -3, 3, -4, -4, 9, -7, -5, -8, 6, -5, 0, 1, -8, 8, 10, -5, -2, -9, 2, -3, -9, 6]\n"}︡{"done":true}
︠170917ea-8d54-4c61-ae01-d9e3776ba6abs︠
# Simulación del intercambio de claves
# eA:= clave secreta Alice, eB:= clave secreta Bob
import time
l=l_15
eA= [randint(-10,10) for i in range(len(l))] 
print 'La clave secreta de Alice es', eA
eB= [randint(-10,10) for i in range(len(l))]
print 'La clave secreta de Bob es', eB
p= 4*prod(l)-1
print 'El primo p es', p

start= time.clock()
Ali= class_group_action(p,0,l,eA)
end= time.clock()-start
print end
print 'La clave pública de Alice es', Ali
Bob= class_group_action(p,0,l,eB)
print 'La clave pública de Bob es', Bob

Ali_S= class_group_action(p,Bob,l,eA)
Bob_S= class_group_action(p,Ali,l,eB)

if(Ali_S==Bob_S):
    print 'El secreto compartido es', Ali_S
    
#%timeit class_group_action(p,0,l,eA)
︡c28fec1d-1b79-4a1b-acfc-9f90d9758d87︡{"stdout":"La clave secreta de Alice es [4, 0, -4, 6, -2, 5, 2, -10, 8, -10, -3, -3, -10, 4, -10, -10, 0, 3, -2, 6, 8, 10, 10, 7, 2, 7]\n"}︡{"stdout":"La clave secreta de Bob es [-7, 10, 8, -3, -8, -7, 0, -5, 1, -5, 7, -6, -4, -9, 8, -4, -10, 9, -7, 1, -2, 9, -7, -5, -3, -7]\n"}︡{"stdout":"El primo p es 42415119603316492960317919068130437336109619\n"}︡{"stdout":"250.925763\n"}︡{"stdout":"La clave pública de Alice es 19744944774945302774916641030403738818707012\n"}︡{"stdout":"La clave pública de Bob es 9581306418934792977207923885242168687068884\n"}︡{"stdout":"El secreto compartido es 40528030412639797291778886706640934626853198\n"}︡{"done":true}
︠e1bcb39a-ae32-40ac-b05c-c746d0340b92︠









